import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import React, { useRef, memo } from "react";
import Paper from "@mui/material/Paper";
import { makeStyles } from "@mui/styles";
import { createTheme, ThemeProvider } from "@mui/material/styles";
import styles from "./styles";
import classnames from "classnames";
import IconButton from "@mui/material/IconButton";
import TrashIcon from "@mui/icons-material/Delete";
import TextField from "@mui/material/TextField";
import Select from "react-select";
import CheckIcon from "@mui/icons-material/Check";
import { asMutable } from "seamless-immutable";
import { Button } from "@mui/material";
var theme = createTheme();
var useStyles = makeStyles(function (theme) {
  return styles;
});
export var RegionLabel = function RegionLabel(_ref) {
  var region = _ref.region,
      editing = _ref.editing,
      allowedClasses = _ref.allowedClasses,
      allowedTags = _ref.allowedTags,
      onDelete = _ref.onDelete,
      _onChange = _ref.onChange,
      onClose = _ref.onClose,
      onOpen = _ref.onOpen,
      onRegionClassAdded = _ref.onRegionClassAdded,
      allowComments = _ref.allowComments;
  var classes = useStyles();
  var commentInputRef = useRef(null);

  var onCommentInputClick = function onCommentInputClick(_) {
    // The TextField wraps the <input> tag with two divs
    var commentInput = commentInputRef.current.children[0].children[0];
    if (commentInput) return commentInput.focus();
  };

  return React.createElement(ThemeProvider, {
    theme: theme
  }, !["ai-point", "ai-rm-point"].includes(region.type) ? React.createElement(Paper, {
    onClick: function onClick() {
      return !editing ? onOpen(region) : null;
    },
    className: classnames(classes.regionInfo, {
      highlighted: region.highlighted
    })
  }, !editing ? React.createElement(React.Fragment, null, region.cls ? React.createElement("div", null, region.cls && React.createElement("div", {
    className: "name",
    style: {
      fontFamily: "Quicksand"
    }
  }, React.createElement("div", {
    className: "circle",
    style: {
      backgroundColor: region.color
    }
  }), region.cls), region.tags && React.createElement("div", {
    className: "tags"
  }, region.tags.map(function (t, i) {
    return React.createElement("div", {
      key: i,
      className: "tag"
    }, t.value);
  }))) : React.createElement("div", {
    style: {
      fontFamily: "Quicksand"
    }
  }, "Select Class")) : React.createElement("div", {
    style: {
      width: 200
    }
  }, React.createElement("div", {
    style: {
      display: "flex",
      flexDirection: "row"
    }
  }, React.createElement("div", {
    style: {
      display: "flex",
      backgroundColor: region.color || "#888",
      color: "#fff",
      padding: 4,
      paddingLeft: 8,
      paddingRight: 8,
      borderRadius: 4,
      fontWeight: "bold",
      textShadow: "0px 0px 5px rgba(0,0,0,0.4)"
    }
  }, region.type), React.createElement("div", {
    style: {
      flexGrow: 1
    }
  }), React.createElement(IconButton, {
    onClick: function onClick() {
      return onDelete(region);
    },
    tabIndex: -1,
    style: {
      width: 22,
      height: 22
    },
    size: "small",
    variant: "outlined"
  }, React.createElement(TrashIcon, {
    style: {
      marginTop: -8,
      width: 16,
      height: 16
    }
  }))), (allowedClasses || []).length > 0 && React.createElement("div", {
    style: {
      marginTop: 6
    }
  }, React.createElement(Select, {
    placeholder: "Classification",
    maxMenuHeight: 130,
    styles: {
      menuList: function menuList(base) {
        return _objectSpread({}, base, {
          "::-webkit-scrollbar-thumb:hover": {
            backgroundColor: "#555"
          },
          "::-webkit-scrollbar-track": {
            borderRadius: "4px",
            backgroundColor: "#f5f5f5",
            boxShadow: "inset 0 0 2px rgba(0, 0, 0, 0.3)"
          },
          "::-webkit-scrollbar": {
            width: "6px",
            backgroundColor: "#f5f5f5"
          },
          "::-webkit-scrollbar-thumb": {
            borderRadius: "4px",
            backgroundColor: "#afb5b8",
            boxShadow: "inset 0 0 2px rgba(0, 0, 0, 0.3)"
          }
        });
      }
    },
    onChange: function onChange(o, actionMeta) {
      if (actionMeta.action === "create-option") {
        onRegionClassAdded(o.value);
      }

      _onChange(_objectSpread({}, region, {
        cls: o.value,
        tags: []
      })); // return onClose(region)

    },
    value: region.cls ? {
      label: region.cls,
      value: region.cls
    } : // ? { label: region.cls, value: region.cls }
    {
      label: "Select...",
      value: "Select..."
    },
    options: asMutable(allowedClasses.map(function (c) {
      return {
        value: c,
        label: c
      };
    }))
  })), (Object.keys(allowedTags) || []).length > 0 && allowedTags[region.cls] && React.createElement("div", {
    style: {
      marginTop: 4
    }
  }, React.createElement(Select, {
    maxMenuHeight: 130,
    styles: {
      menuList: function menuList(base) {
        return _objectSpread({}, base, {
          "::-webkit-scrollbar-thumb:hover": {
            backgroundColor: "#555"
          },
          "::-webkit-scrollbar-track": {
            borderRadius: "4px",
            backgroundColor: "#f5f5f5",
            boxShadow: "inset 0 0 2px rgba(0, 0, 0, 0.3)"
          },
          "::-webkit-scrollbar": {
            width: "6px",
            backgroundColor: "#f5f5f5"
          },
          "::-webkit-scrollbar-thumb": {
            borderRadius: "4px",
            backgroundColor: "#afb5b8",
            boxShadow: "inset 0 0 2px rgba(0, 0, 0, 0.3)"
          }
        });
      }
    },
    onChange: function onChange(newTags) {
      console.log(newTags);

      _onChange(_objectSpread({}, region, {
        tags: newTags ? newTags.map(function (t) {
          return {
            value: "".concat(t.category, "__").concat(t.value),
            category: t.category
          };
        }) : []
      }));
    },
    placeholder: "Tags",
    value: (region.tags || []).map(function (c) {
      return {
        label: c.value.split("__")[1],
        value: c.value.split("__")[1],
        category: c.category
      };
    }),
    isMulti: true,
    options: allowedTags[region.cls].regionTags.map(function (c) {
      return {
        label: c.category,
        options: c.options.map(function (t) {
          return {
            label: t,
            value: t,
            category: c.category
          };
        })
      };
    }).filter(function (option) {
      var _region$tags;

      return !(region === null || region === void 0 ? void 0 : (_region$tags = region.tags) === null || _region$tags === void 0 ? void 0 : _region$tags.find(function (tag) {
        return tag.category === option.label;
      }));
    })
  })), allowComments && React.createElement(TextField, {
    InputProps: {
      className: classes.commentBox
    },
    fullWidth: true,
    multiline: true,
    rows: 3,
    ref: commentInputRef,
    onClick: onCommentInputClick,
    value: region.comment || "",
    onChange: function onChange(event) {
      return _onChange(_objectSpread({}, region, {
        comment: event.target.value
      }));
    },
    placeholder: "Description..."
  }), onClose && React.createElement("div", {
    style: {
      marginTop: 4,
      display: "flex"
    }
  }, React.createElement("div", {
    style: {
      flexGrow: 1
    }
  }), React.createElement(Button, {
    onClick: function onClick() {
      _onChange(_objectSpread({}, region, {
        cls: region.cls ? region.cls : allowedClasses[0]
      }));

      onClose(region);
    },
    size: "small",
    variant: "contained",
    color: "primary"
  }, React.createElement(CheckIcon, null))))) : React.createElement(Paper, null, React.createElement(IconButton, {
    onClick: function onClick() {
      return onDelete(region);
    },
    tabIndex: -1,
    style: {
      width: 22,
      height: 22
    },
    size: "small",
    variant: "outlined"
  }, React.createElement(TrashIcon, {
    style: {
      width: 16,
      height: 16
    }
  }))));
};
export default memo(RegionLabel, function (prevProps, nextProps) {
  return prevProps.editing === nextProps.editing && prevProps.region === nextProps.region;
});