import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import React, { useRef, memo } from "react";
import Paper from "@mui/material/Paper";
import { makeStyles } from "@mui/styles";
import { createTheme, ThemeProvider } from "@mui/material/styles";
import styles from "./styles";
import classnames from "classnames";
import IconButton from "@mui/material/IconButton";
import TrashIcon from "@mui/icons-material/Delete";
import Select from "react-select";
import CheckIcon from "@mui/icons-material/Check";
import { Button } from "@mui/material";
var theme = createTheme();
var useStyles = makeStyles(function (theme) {
  return styles;
});
export var RegionLabelSub = function RegionLabelSub(_ref) {
  var region = _ref.region,
      editing = _ref.editing,
      allowedClasses = _ref.allowedClasses,
      allowedTags = _ref.allowedTags,
      onDelete = _ref.onDelete,
      _onChange = _ref.onChange,
      onClose = _ref.onClose,
      onOpen = _ref.onOpen,
      onRegionClassAdded = _ref.onRegionClassAdded,
      allowComments = _ref.allowComments,
      subClassMenuData = _ref.subClassMenuData;
  var classes = useStyles();
  var commentInputRef = useRef(null); // eslint-disable-next-line

  var onCommentInputClick = function onCommentInputClick(_) {
    // The TextField wraps the <input> tag with two divs
    var commentInput = commentInputRef.current.children[0].children[0];
    if (commentInput) return commentInput.focus();
  };

  return React.createElement(ThemeProvider, {
    theme: theme
  }, React.createElement(Paper, {
    onClick: function onClick() {
      return !editing ? onOpen(region) : null;
    },
    className: classnames(classes.regionInfo, {
      highlighted: region.highlighted
    })
  }, React.createElement("div", {
    style: {
      width: 200
    }
  }, React.createElement("div", {
    style: {
      display: "flex",
      flexDirection: "row"
    }
  }, React.createElement("div", {
    style: {
      display: "flex",
      backgroundColor: region.color || "#888",
      color: "#fff",
      padding: 4,
      paddingLeft: 8,
      paddingRight: 8,
      borderRadius: 4,
      fontWeight: "bold",
      textShadow: "0px 0px 5px rgba(0,0,0,0.4)"
    }
  }, region.type, "-point[", subClassMenuData.pointIndex, "]"), React.createElement("div", {
    style: {
      flexGrow: 1
    }
  }), React.createElement(IconButton, {
    onClick: function onClick() {
      onDelete(region);
      onClose(region);
    },
    tabIndex: -1,
    style: {
      width: 22,
      height: 22
    },
    size: "small",
    variant: "outlined"
  }, React.createElement(TrashIcon, {
    style: {
      marginTop: -8,
      width: 16,
      height: 16
    }
  }))), (Object.keys(allowedTags) || []).length > 0 && React.createElement("div", {
    style: {
      marginTop: 4
    }
  }, React.createElement(Select, {
    placeholder: "Tags",
    maxMenuHeight: 130,
    styles: {
      menuList: function menuList(base) {
        return _objectSpread({}, base, {
          "::-webkit-scrollbar-thumb:hover": {
            backgroundColor: "#555"
          },
          "::-webkit-scrollbar-track": {
            borderRadius: "4px",
            backgroundColor: "#f5f5f5",
            boxShadow: "inset 0 0 2px rgba(0, 0, 0, 0.3)"
          },
          "::-webkit-scrollbar": {
            width: "6px",
            backgroundColor: "#f5f5f5"
          },
          "::-webkit-scrollbar-thumb": {
            borderRadius: "4px",
            backgroundColor: "#afb5b8",
            boxShadow: "inset 0 0 2px rgba(0, 0, 0, 0.3)"
          }
        });
      }
    },
    onChange: function onChange(newTags) {
      _onChange(_objectSpread({}, region, {
        tags: newTags ? newTags.map(function (t) {
          return {
            value: "".concat(t.category, "__").concat(t.value),
            category: t.category
          };
        }) : []
      }), "pointsWithTag");
    },
    value: region.pointsWithTag[subClassMenuData.pointIndex].tags.map(function (t) {
      return {
        label: t.value.split("__")[1],
        value: t.value.split("__")[1],
        category: t.category
      };
    }),
    isMulti: true,
    options: allowedTags[region.cls].pointTags.map(function (c) {
      return {
        label: c.category,
        options: c.options.map(function (t) {
          return {
            label: t,
            value: t,
            category: c.category
          };
        })
      };
    }).filter(function (option) {
      var _region$pointsWithTag;

      return !(region === null || region === void 0 ? void 0 : (_region$pointsWithTag = region.pointsWithTag) === null || _region$pointsWithTag === void 0 ? void 0 : _region$pointsWithTag[subClassMenuData.pointIndex].tags.find(function (tag) {
        return tag.category === option.label;
      }));
    })
  })), onClose && React.createElement("div", {
    style: {
      marginTop: 4,
      display: "flex"
    }
  }, React.createElement("div", {
    style: {
      flexGrow: 1
    }
  }), React.createElement(Button, {
    onClick: function onClick() {
      onClose(region);
    },
    size: "small",
    variant: "contained",
    color: "primary"
  }, React.createElement(CheckIcon, null))))));
};
export default memo(RegionLabelSub, function (prevProps, nextProps) {
  return prevProps.editing === nextProps.editing && prevProps.region === nextProps.region;
});