import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useState } from "react";
import { Box, ButtonBase, Menu, MenuItem, Modal } from "@mui/material";
import MoreIcon from "@mui/icons-material/MoreVert";
import LayersIcon from "@mui/icons-material/Layers";
import CloseIcon from "@mui/icons-material/Close";

var RegionOptions = function RegionOptions(_ref) {
  var _state$images$state$s, _state$images$state$s2;

  var isVideo = _ref.isVideo,
      state = _ref.state,
      dispatch = _ref.dispatch,
      region = _ref.region;

  var _useState = useState(null),
      _useState2 = _slicedToArray(_useState, 2),
      anchorEl = _useState2[0],
      setAnchorEl = _useState2[1];

  var open = Boolean(anchorEl);

  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };

  var handleClose = function handleClose() {
    setAnchorEl(null);
  };

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      modalOpen = _useState4[0],
      setModalOpen = _useState4[1];

  var _useState5 = useState(1),
      _useState6 = _slicedToArray(_useState5, 2),
      copyCount = _useState6[0],
      setCopyCount = _useState6[1];

  var style = {
    position: "absolute",
    top: "50%",
    left: "50%",
    transform: "translate(-50%, -50%)",
    borderRadius: "2px",
    width: 400,
    bgcolor: "background.paper",
    boxShadow: 24,
    p: 2,
    display: "flex",
    flexDirection: "column",
    gap: "20px"
  };
  return React.createElement(React.Fragment, null, React.createElement(MoreIcon, {
    onClick: handleClick,
    className: "icon2"
  }), React.createElement(Menu, {
    container: document.querySelector(".fullscreen"),
    sx: {
      "& ul": {
        padding: "4px 0px"
      }
    },
    anchorEl: anchorEl,
    open: open,
    onClose: handleClose
  }, React.createElement(MenuItem, {
    disabled: !isVideo || !((_state$images$state$s = state.images[state.selectedImage]) === null || _state$images$state$s === void 0 ? void 0 : (_state$images$state$s2 = _state$images$state$s.regions) === null || _state$images$state$s2 === void 0 ? void 0 : _state$images$state$s2.find(function (r) {
      return r.id === region.id;
    })),
    sx: {
      fontSize: 14,
      display: "flex",
      gap: "5px"
    },
    onClick: function onClick() {
      handleClose();
      setModalOpen(true);
    }
  }, React.createElement(LayersIcon, {
    sx: {
      opacity: 0.8,
      width: 16,
      height: 16
    }
  }), "Propagate")), React.createElement(Modal, {
    container: document.querySelector(".fullscreen"),
    open: modalOpen,
    onClose: function onClose() {
      return setModalOpen(false);
    }
  }, React.createElement(Box, {
    sx: style
  }, React.createElement(Box, {
    sx: {
      display: "flex"
    }
  }, React.createElement("span", {
    style: {
      color: "rgba(0,0,0,.85)",
      fontWeight: 500,
      marginRight: "auto"
    }
  }, "Confirm propagation"), React.createElement(CloseIcon, {
    sx: {
      cursor: "pointer"
    },
    onClick: function onClick() {
      return setModalOpen(false);
    }
  })), React.createElement(Box, {
    sx: {
      display: "flex",
      width: "100%"
    }
  }, React.createElement("span", {
    style: {
      width: "90%",
      fontSize: "15px"
    }
  }, "How many copies do you want to create?"), React.createElement("input", {
    onChange: function onChange(e) {
      return e.target.value > 1 ? setCopyCount(e.target.value) : setCopyCount(1);
    },
    value: copyCount,
    type: "number",
    style: {
      width: "10%"
    },
    min: 1,
    max: state.images.slice(state.selectedImage).length - 2
  })), React.createElement(Box, {
    sx: {
      display: "flex"
    }
  }, React.createElement(ButtonBase, {
    onClick: function onClick() {
      setModalOpen(false);
      dispatch({
        type: "PROPAGATE",
        copyCount: copyCount
      });
    },
    sx: {
      "&.Mui-disabled": {
        background: "#eaeaea",
        color: "#c0c0c0"
      },
      fontFamily: "inherit",
      fontSize: "14px",
      padding: "6px 10px",
      borderRadius: "2px",
      bgcolor: "#408fff",
      color: "#fff",
      marginLeft: "auto"
    },
    disabled: copyCount > state.images.slice(state.selectedImage).length - 2 || state.images.slice(state.selectedImage).length - 2 < 0
  }, "Yes")))));
};

export default RegionOptions;