import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import { initializeApp } from "firebase/app";
import { getFunctions, httpsCallable } from "firebase/functions"; // import { toast } from "react-toastify"

export var promptSAM =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee(state, dispatch) {
    var _selectedImage$region, selectedImage, aiPoints, inclusivePoints, exclusivePoints, firebaseApp, functions, _promptSAM, _ref2, data;

    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(state.selectedTool === "create-ai")) {
              _context.next = 13;
              break;
            }

            selectedImage = state.images[state.selectedImage];
            aiPoints = selectedImage === null || selectedImage === void 0 ? void 0 : (_selectedImage$region = selectedImage.regions) === null || _selectedImage$region === void 0 ? void 0 : _selectedImage$region.filter(function (r) {
              return ["ai-point", "ai-rm-point"].includes(r.type);
            });
            inclusivePoints = aiPoints.filter(function (r) {
              return r.type === "ai-point";
            }).map(function (r) {
              return {
                x: r.x * selectedImage.pixelSize.w,
                y: r.y * selectedImage.pixelSize.h
              };
            });
            exclusivePoints = aiPoints.filter(function (r) {
              return r.type === "ai-rm-point";
            }).map(function (r) {
              return {
                x: r.x * selectedImage.pixelSize.w,
                y: r.y * selectedImage.pixelSize.h
              };
            });
            firebaseApp = state.firebaseConfig ? initializeApp(state.firebaseConfig) : null;
            functions = getFunctions(firebaseApp);
            _promptSAM = httpsCallable(functions, "promptSAM");
            _context.next = 10;
            return _promptSAM({
              imageURL: selectedImage.src,
              prompts: [{
                inclusivePoints: inclusivePoints,
                exclusivePoints: exclusivePoints
              }]
            });

          case 10:
            _ref2 = _context.sent;
            data = _ref2.data;
            dispatch({
              type: "PROMPT_SAM",
              data: data
            }); // toast.promise(
            //   async () => {
            //     const { data } = await promptSAM({
            //       imageURL: selectedImage.src,
            //       prompts: [
            //         {
            //           inclusivePoints,
            //           exclusivePoints,
            //         },
            //       ],
            //     })
            //     dispatch({
            //       type: "PROMPT_SAM",
            //       data,
            //     })
            //   },
            //   {
            //     pending: "Wait for segmentation loading",
            //     error: "Error occurred",
            //   }
            // )

          case 13:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function promptSAM(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();